systemheader:(XMACRO)#                                                  XMAC   1
##*****************************************************************##   XMAC   2
##                    The XTAL System.                             ##   XMAC   3
## Software for Crystallographic Structure Solution and Refinement.##   XMAC   4
## Copyright (C) 2000  The University of Western Australia.        ##   XMAC   5
##     email  xtal@crystal.uwa.edu.au                              ##   XMAC   6
##     web    http://xtal.crystal.uwa.edu.au/                      ##   XMAC   7
##                                                                 ##   XMAC   8
## This program is free software; you can redistribute it and/or   ##   XMAC   9
## modify it under the terms of the GNU General Public License as  ##   XMAC  10
## published by the Free Software Foundation.                      ##   XMAC  11
##                                                                 ##   XMAC  12
## This program is distributed in the hope that it will be useful, ##   XMAC  13
## but WITHOUT ANY WARRANTY; without even the implied warranty of  ##   XMAC  14
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the   ##   XMAC  15
## GNU General Public License for more details.                    ##   XMAC  16
##                                                                 ##   XMAC  17
## You should have received a copy of the GNU General Public       ##   XMAC  18
## License along with this program; if not, write to the Free      ##   XMAC  19
## Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,  ##   XMAC  20
## MA  02111-1307  USA                                             ##   XMAC  21
##                                                                 ##   XMAC  22
##      X  T  A  L    S  Y  S  T  E  M    M  A  C  R  O  S         ##   XMAC  23
##                                                                 ##   XMAC  24
##                          A  N  D                                ##   XMAC  25
##                                                                 ##   XMAC  26
##      X  T  A  L    S  Y  S  T  E  M    C  O  M  M  O  N         ##   XMAC  27
##                                                                 ##   XMAC  28
##*****************************************************************##   XMAC  29
##                                                                      XMAC  30
##                                                                      XMAC  31
##              >>>>>> These two macros specify the version and the     XMAC  32
##              >>>>>> revision status of this macro library. Do not    XMAC  33
##              >>>>>> change these unless advised to do so.            XMAC  34
##                                                                      XMAC  35
macro:(version:,3.7)#                  For xtal3.6 version              XMAC  36
##macro:(version:,_GX)#                For the GX version               XMAC  37
macro:(update:,feb00:compiler:)#                                        XMAC  38
##                                                                      XMAC  39
##                                                                      XMAC  40
##                                                                      XMAC  41
##              >>>>>> This macro must be changed to match the target   XMAC  42
##              >>>>>> compiler. The appropriate definitions and code   XMAC  43
##              >>>>>> are then automatically selected by the RFPP.     XMAC  44
##                                                                      XMAC  45
macro:(compiler:,UNXULT)#                                               XMAC  46
##                                                                      XMAC  47
##                      Macros are defined for the compilers:           XMAC  48
##                                                                      XMAC  49
##              UNXsos  Unix BSD 4.3  Sun OS f77                        XMAC  50
##              UNXsny  Unix BSD 4.3  Sony f77                          XMAC  51
##              UNXult  Unix Ultrix   DEC f77                           XMAC  52
##              UNXdec  Unix OSF/AXP True64 COMPAQ/DEC f77              XMAC  53
##              UNXibm  Unix system V RISC6000 f77                      XMAC  54
##              UNXcra  Unix system V Cray UNICOS f77                   XMAC  55
##              UNXcvx  Unix system V Convex (3820) f77                 XMAC  56
##              UNXsgi  Unix system V Silicon Graphics f77              XMAC  57
##              UNXhp   Unix system V Hewlett Packard f77               XMAC  58
##              UNXlnx  Unix Linux 1.0 f2c + gcc                        XMAC  59
##                                                                      XMAC  60
##              VMS     DEC VAX/VMS F77                                 XMAC  61
##              CRAY    Cray non-unix F77                               XMAC  62
##              MAC     Apple Macintosh Language Systems F77            XMAC  63
##              SIE     Siemens ebcdic  F77                             XMAC  64
##              OS2     IBM OS/2 PC    F77                              XMAC  65
##              IBM     IBM ebcdic non-unix F77                         XMAC  66
##              LHPC    Lahey F77L 80N86 for PC                         XMAC  67
##              MSPC    Microsoft F77 for PC                            XMAC  68
##              MSNT    Digital f90 for Microsoft NT                    XMAC  69
##              SLPC    Salford F77 for PC                              XMAC  70
#                                                                       XMAC  71
#                                                                       XMAC  72
#                                                                       XMAC  73
#                                                                       XMAC  74
#                                                                       XMAC  75
#        INSTALLATION-DEPENDENT MACRO DEFINITIONS                       XMAC  76
#        ----------------------------------------                       XMAC  77
#                                                                       XMAC  78
#                                                                       XMAC  79
##             >>>>>>>  Set the memory size of the QX array in WORDS.   XMAC  80
#                                                                       XMAC  81
macro:(memmax:,3000000)#                                                XMAC  82
#                                                                       XMAC  83
##             >>>>>>>  Set default printer characteristics.            XMAC  84
#                                                                       XMAC  85
macro:(nchin:,15)## chars/inch                                          XMAC  86
macro:(nliin:,8)## lines/inch                                           XMAC  87
macro:(mxchln:,117)## chars/line                                        XMAC  88
macro:(mxlnpg:,91)## lines/page                                         XMAC  89
#                                                                       XMAC  90
#                                                                       XMAC  91
##             >>>>>>>  Set archive bdf masterfile support.             XMAC  92
#                                                                       XMAC  93
macro:(masterfile:,yes:)#                                               XMAC  94
#                                                                       XMAC  95
#                                                                       XMAC  96
##             >>>>>>>  Set device numbers for files.                   XMAC  97
#                                                                       XMAC  98
macro:(uniterr:,3)## std line error device (for errfile:)               XMAC  99
macro:(unitpch:,4)## std line punch device (for compid.pch)             XMAC 100
macro:(unitinp:,5)## std line input device (for compid.dat or .inp)     XMAC 101
macro:(unitprt:,6)## std line print device (for compid.lst or .prt)     XMAC 102
#                                                                       XMAC 103
macro:(unitfm0:,7)## sequential line device 0 (scratch)                 XMAC 104
macro:(unitfm1:,8)## sequential line device 1 (scratch)                 XMAC 105
macro:(unitfm2:,9)## sequential line device 2 (scratch)                 XMAC 106
#                                                                       XMAC 107
macro:(unitda1:,10)## direct access device 1 (scratch line or binary)   XMAC 108
macro:(unitda2:,11)## direct access device 2 (scratch line or binary)   XMAC 109
macro:(unitda3:,12)## direct access device 3 (scratch line or binary)   XMAC 110
#                                                                       XMAC 111
macro:(unitin1:,13)## nonstd line input device (for .dat or .inp)       XMAC 112
macro:(unitpr1:,14)## nonstd line print device (for .lst or .prt)       XMAC 113
#                                                                       XMAC 114
macro:(unitbdf:,15)## archive binary file devices (from n to n+7)       XMAC 115
#                                                                       XMAC 116
#                                                                       XMAC 117
#                                                                       XMAC 118
#                                                                       XMAC 119
#                                                                       XMAC 120
#                                                                       XMAC 121
#                COMPILER-SPECIFIC MACRO DEFINITIONS                    XMAC 122
#                -----------------------------------                    XMAC 123
#                                                                       XMAC 124
##>>>>>>> These macro definitions are selected via the compiler:<<<<<<  XMAC 125
##>>>>>>> definition and should not require local adjustment.   <<<<<<  XMAC 126
##>>>>>>> If they do be very careful with the use of ifsel: and <<<<<<  XMAC 127
##>>>>>>> endsel: commands. Misuse can cause strange errors.    <<<<<<  XMAC 128
#                                                                       XMAC 129
#                                                                       XMAC 130
select:(compiler:)#                                                     XMAC 131
#                                                                       XMAC 132
#                                                                       XMAC 133
#------------------------- FILENAME CONSTRUCTION --------------------   XMAC 134
#                                                                       XMAC 135
ifsel:(IBM)#                                                            XMAC 136
macro:(filename:,'XTAL'//$2)## File name structure of XTAL files        XMAC 137
macro:(tabchr:,CHAR(05))#                                               XMAC 138
ifsel:#                                                                 XMAC 139
macro:(filename:,$1//'.'//$2)## File name structure of XTAL files       XMAC 140
macro:(tabchr:,CHAR(09))#                                               XMAC 141
endsel:#                                                                XMAC 142
#                                                                       XMAC 143
#------------------------- BINARY FILE RECORDS ----------------------   XMAC 144
#                                                                       XMAC 145
ifsel:(IBM)#                                                            XMAC 146
macro:(bdfbuf:,2868)#                ## QX buffer length in WORDS       XMAC 147
macro:(bdfchr:,11472)#               ## Open record length in BYTES     XMAC 148
ifsel:(SIE)#                                                            XMAC 149
macro:(bdfbuf:,500)#                 ## QX buffer length in WORDS       XMAC 150
macro:(bdfchr:,2000)#                ## Open record length in BYTES     XMAC 151
ifsel:(UNXCVX)#                                                         XMAC 152
macro:(bdfbuf:,1024)#                ## QX buffer length in WORDS#      XMAC 153
macro:(bdfchr:,4096)#                ## Open record length in BYTES#    XMAC 154
ifsel:#                                                                 XMAC 155
macro:(bdfbuf:,2048)#                ## QX buffer length in WORDS       XMAC 156
macro:(bdfchr:,8192)#                ## Open record length in BYTES     XMAC 157
endsel:#                                                                XMAC 158
#                                                                       XMAC 159
#------------------------ FORCE NEW PAGE ---------------------------    XMAC 160
#                                                                       XMAC 161
ifsel:(IBM)#                                                            XMAC 162
macro:(nextpage:,[WRITE(ioprt:,'(A1)') CHAR(241)])#                     XMAC 163
ifsel:#                                                                 XMAC 164
macro:(nextpage:,[WRITE(ioprt:,'(A1)') CHAR(12)])#                      XMAC 165
endsel:#                                                                XMAC 166
#                                                                       XMAC 167
#---------------------- BOOLEAN FUNCTIONS --------------------------    XMAC 168
#                                                                       XMAC 169
ifsel:(IBM)#                                                            XMAC 170
macro:(hex80:,Z80808080)#                                               XMAC 171
macro:(xor:,IEOR(($1),($2)))#                                           XMAC 172
macro:(and:,IAND(($1),($2)))#                                           XMAC 173
ifsel:(SIE)#                                                            XMAC 174
macro:(hex80:,Z80808080)#                                               XMAC 175
macro:(xor:,IXOR(($1),($2)))#                                           XMAC 176
macro:(and:,IAND(($1),($2)))#                                           XMAC 177
ifsel:(MAC)#                                                            XMAC 178
macro:(hex80:,$80808080)#                                               XMAC 179
macro:(xor:,IEOR(($1),($2)))#                                           XMAC 180
macro:(and:,IAND(($1),($2)))#                                           XMAC 181
ifsel:(LHPC)#                                                           XMAC 182
macro:(hex80:,Z'80808080')#                                             XMAC 183
macro:(xor:,IEOR(($1),($2)))#                                           XMAC 184
macro:(and:,IAND(($1),($2)))#                                           XMAC 185
ifsel:(CRAY)#                                                           XMAC 186
macro:(hex80:,2155905152)#                                              XMAC 187
macro:(xor:,XOR(($1),($2)))#                                            XMAC 188
macro:(and:,AND(($1),($2)))#                                            XMAC 189
ifsel:(VMS)#                                                            XMAC 190
macro:(hex80:,-2139062144)#                                             XMAC 191
macro:(xor:,($1).XOR.($2))#                                             XMAC 192
macro:(and:,($1)&($2))#                                                 XMAC 193
ifsel:(UNXCVX)#                                                         XMAC 194
macro:(hex80:,X'80808080')#                                             XMAC 195
macro:(xor:,JIEOR(($1),($2)))#                                          XMAC 196
macro:(and:,JIAND(($1),($2)))#                                          XMAC 197
ifsel:(UNXHP)#                                                          XMAC 198
macro:(hex80:,-2139062144)#                                             XMAC 199
macro:(xor:,IXOR(($1),($2)))#                                           XMAC 200
macro:(and:,IAND(($1),($2)))#                                           XMAC 201
ifsel:#                                                                 XMAC 202
macro:(hex80:,-2139062144)#                                             XMAC 203
macro:(xor:,XOR(($1),($2)))#                                            XMAC 204
macro:(and:,AND(($1),($2)))#                                            XMAC 205
endsel:#                                                                XMAC 206
#                                                                       XMAC 207
#-----------------------  MOVE STRINGS  ----------------------------    XMAC 208
#                                                                       XMAC 209
ifsel:(VMS,MAC)#                                                        XMAC 210
macro:(movepakwd:,CALL AA52($1,$2))#                                    XMAC 211
macro:(movereal:, CALL AA51($1,$2,$3,$4,$5,$6))#                        XMAC 212
macro:(movechar:, CALL AA55(%REF($1),$2,%REF($3),$4,$5,$6))#            XMAC 213
macro:(movector:, CALL AA56(%REF($1),$2,%REF($3),$4,$5,$6))#            XMAC 214
macro:(movertoc:, CALL AA57(%REF($1),$2,%REF($3),$4,$5,$6))#            XMAC 215
ifsel:#                                                                 XMAC 216
macro:(movepakwd:,CALL AA52($1,$2))#                                    XMAC 217
macro:(movereal:, CALL AA51($1,$2,$3,$4,$5,$6))#                        XMAC 218
macro:(movechar:, CALL AA55($1,$2,$3,$4,$5,$6))#                        XMAC 219
macro:(movector:, CALL AA56($1,$2,$3,$4,$5,$6))#                        XMAC 220
macro:(movertoc:, CALL AA57($1,$2,$3,$4,$5,$6))#                        XMAC 221
endsel:#                                                                XMAC 222
#                                                                       XMAC 223
#--------------------WORD/CHAR SPECIFICATION------------------------    XMAC 224
#                                                                       XMAC 225
ifsel:(UNXCRA,CRAY)#                                                    XMAC 226
macro:(mxbtwd:,64)#                                                     XMAC 227
macro:(mxbtch:,8)#                                                      XMAC 228
macro:(mxchwd:,8)#                                                      XMAC 229
macro:(mxsgfp:,14)#                                                     XMAC 230
macro:(mnfpnbr:,1.0E-2447)#                                             XMAC 231
ifsel:#                                                                 XMAC 232
macro:(mxbtwd:,32)#                                                     XMAC 233
macro:(mxbtch:,8)#                                                      XMAC 234
macro:(mxchwd:,4)#                                                      XMAC 235
macro:(mxsgfp:,7)#                                                      XMAC 236
macro:(mnfpnbr:,1.0E-37)#                                               XMAC 237
endsel:#                                                                XMAC 238
ifsel:(MSNT,UNXULT,UNXSOS)#                                             XMAC 239
macro:(pointer:,INTEGER )#             For storing 32 bit pointers      XMAC 240
ifsel:#                                                                 XMAC 241
macro:(pointer:,INTEGER*8 )#           For storing 64 bit pointers      XMAC 242
endsel:#                                                                XMAC 243
#                                                                       XMAC 244
#----------------------- LOCALSTART/STOP ---------------------------    XMAC 245
#                                                                       XMAC 246
ifsel:(IBM)#                                                            XMAC 247
macro:(localstart:,$(CALL AA70(KIK);CALL ERRSET(151,0,-1)$))#           XMAC 248
ifsel:(SIE)#                                                            XMAC 249
macro:(localstart:,CALL AA70(KIK))#                                     XMAC 250
ifsel:(VMS)#                                                            XMAC 251
macro:(localstart:,$(OPEN(unitprt:,STATUS='NEW',#                       XMAC 252
FORM='FORMATTED',ACCESS='SEQUENTIAL',CARRIAGECONTROL='LIST')#           XMAC 253
CALL AA75#                             Set xtalhome                     XMAC 254
IF(XTALHOME(1^1)==' ') XTALHOME='[]' $) )#                              XMAC 255
ifsel:(MAC)#                                                            XMAC 256
macro:(localstart:,$(CALLALERTBOX$#                                     XMAC 257
('First choose an input file, then a list file')#                       XMAC 258
OPEN(unitinp:,FILE=*,FILETYPE='TEXT')#                                  XMAC 259
OPEN(unitprt:,FILE=*'Output list file name:',STATUS='NEW')#             XMAC 260
IWIWIW=JVREFNUM(unitinp:);CALL F_SETVOLUME(IWIWIW)$))#                  XMAC 261
ifsel:(SLPC)#                                                           XMAC 262
macro:(localstart:,[$(string:(TIME@,8);string:(FN,8);$#                 XMAC 263
LOGICAL EXS;EXS=.FALSE.; REPEAT#                                        XMAC 264
$(; IF(EXS) BREAK; PRINT *,' Type input file name (8 chars)';$#         XMAC 265
READ (*,'(A8)')FN;INQUIRE(FILE=FN//'.DAT',EXIST=EXS);$)#                XMAC 266
OPEN(unitinp:,FILE=FN//'.DAT',STATUS='OLD')#                            XMAC 267
OPEN(unitprt:,FILE=FN//'.LST',STATUS='UNKNOWN',FORM='PRINTER',#         XMAC 268
ACCESS='SEQUENTIAL')$)])#                                               XMAC 269
ifsel:#                                                                 XMAC 270
macro:(localstart:,$(IWIWIW=0#                                          XMAC 271
CALL GETENV('XTALHOME',XTALHOME)#      Location of extra files          XMAC 272
IF (XTALHOME(1^LNBLNK(XTALHOME))==' ')# For undefined eviron variable   XMAC 273
XTALHOME='./' $) )#                    Make into local directory        XMAC 274
endsel:#                                                                XMAC 275
macro:(localstop:,IWIWIW=0)#                                            XMAC 276
#                                                                       XMAC 277
#                                                                       XMAC 278
#                                                                       XMAC 279
#--------------------REFERENCE FILE IDENTITY------------------------    XMAC 280
#                                                                       XMAC 281
ifsel:(SLPC)#                                                           XMAC 282
macro:(prefix:,)#                                                       XMAC 283
macro:(ext:,)#                                                          XMAC 284
ifsel:(VMS)#                                                            XMAC 285
macro:(prefix:,XTALHOME(1^LNBLNK(XTALHOME))//)#                         XMAC 286
macro:(ext:,//'.')#                                                     XMAC 287
ifsel:#                                                                 XMAC 288
macro:(prefix:,XTALHOME(1^LNBLNK(XTALHOME))//'/'//)#                    XMAC 289
macro:(ext:,)#                                                          XMAC 290
endsel:#                                                                XMAC 291
#                                                                       XMAC 292
#                                                                       XMAC 293
##******************************************************************    XMAC 294
##                                                                      XMAC 295
##                   CONVENIENCE MACRO DEFINITIONS                      XMAC 296
##                   -----------------------------                      XMAC 297
##                                                                      XMAC 298
##>>>>>>>> These macros should not require local adjustment <<<<<<<<    XMAC 299
#                                                                       XMAC 300
macro:(cifdic1:,prefix:'cifdic' ext:)## CIF dictionary                  XMAC 301
macro:(cifdic2:,prefix:'cifdic.loc' )## CIF dictionary (local)          XMAC 302
macro:(cifrequ:,prefix:'cifreq' ext:)## CIF request file                XMAC 303
macro:(cifmapp:,prefix:'cifmap' ext:)## CIF mapping file for CIFIO      XMAC 304
macro:(cifmap2:,prefix:'cifmp2' ext:)## CIF mapping file for CIFENT     XMAC 305
macro:(errfile:,prefix:'xerror' ext:)## error library                   XMAC 306
macro:(symmapp:,prefix:'symmap' ext:)## Spacegroup mapping              XMAC 307
macro:(profile:,prefix:'profil' ext:)## profile database                XMAC 308
macro:(lcifreq:,       'cifreq' ext:)## Local CIF request file          XMAC 309
macro:(xtalpsp:,prefix:'xtalps' ext:)## postscript prolog file          XMAC 310
macro:(xtalpov:,prefix:'xtalpov'ext:)## Povray prolog file              XMAC 311
#                                                                       XMAC 312
macro:(openfmt:,CALL AA50($1, 1, 0,$2))#                                XMAC 313
macro:(opendac:,CALL AA50($1,$2,$3,$4))#                                XMAC 314
macro:(readfmt:,READ($1,$2,END=$3)$4)#                                  XMAC 315
macro:(readdac:,READ($1,$2 REC=$3)$4)#                                  XMAC 316
macro:(writefmt:,WRITE($1,$2)$3)#                                       XMAC 317
macro:(writedac:,WRITE($1,$2 REC=$3)$4)#                                XMAC 318
macro:(closefmt:,CLOSE($1))#                                            XMAC 319
macro:(closedac:,CLOSE($1))#                                            XMAC 320
#                                                                       XMAC 321
macro:(openpch:,CALL AA50(iopch:,1,0,' '))#                             XMAC 322
macro:(writepch:,$(IF(iopch:<0)$(iopch:=-iopch:#                        XMAC 323
openpch:$);WRITE(iopch:,'(A)')$1(1^$2)$))#                              XMAC 324
macro:(closepch:,IF(iopch:>0)$(CLOSE(iopch:);iopch:=-iopch:$))#         XMAC 325
#                                                                       XMAC 326
macro:(bdfreadopen:, opendac:($1,2,bdfchr:,' '))#                       XMAC 327
macro:(bdfwriteopen:,opendac:($1,3,bdfchr:,' '))#                       XMAC 328
macro:(bdfread:, READ ($1,REC=$2+1)$3)#                                 XMAC 329
macro:(bdfwrite:,WRITE($1,REC=$2+1)$3)#                                 XMAC 330
macro:(bdfclose:,CLOSE($1))#                                            XMAC 331
#                                                                       XMAC 332
macro:(inquirefile:,CALL AA50($1, 0,$2,$3))#                            XMAC 333
macro:(inquireunit:,CALL AA50($1,-1, 0,$2))#                            XMAC 334
#                                                                       XMAC 335
macro:(copybdf:,  CALL AA10($1,$2))#                                    XMAC 336
macro:(writepkt:, CALL AA11($1,$2,$3,$4))#                              XMAC 337
macro:(readwpkt:, CALL AA12($1,$2,$3,$4,$5))#                           XMAC 338
macro:(copyfile:, CALL AA13($1,$2,$3,$4))#                              XMAC 339
macro:(rewindbdf:,CALL AA14(8,$1))#                                     XMAC 340
macro:(indexpkt:, CALL AA15($1,$2,$3,$4,$5,$6,$7,$8))#                  XMAC 341
macro:(endrecord:,65535)#                                               XMAC 342
#                                                                       XMAC 343
macro:(linein:,CALL AA54($1,$2,$3,$4))#                                 XMAC 344
macro:(lineout:,[IF($1<=PPRIOR)$(#                                      XMAC 345
DO JQJ=$3,2,-1;IF($2(JQJ^JQJ)!=' ')BREAK#                               XMAC 346
WRITE(ioprt:,"(A)")$2(1^JQJ)$)])#                                       XMAC 347
macro:(linestream:,$(FILEXT(iofm0:)=$1#                                 XMAC 348
openfmt:(iofm0:,' ');IOIN2=ioinp:; ioinp:=iofm0:$))#                    XMAC 349
#                                                                       XMAC 350
macro:(readline:, CALL AA01($1,$2))#                                    XMAC 351
macro:(dcodefld:, CALL AA02)#                                           XMAC 352
macro:(ncodefld:, CALL AA03($1,$2,$3,$4,$5))#                           XMAC 353
macro:(writeline:,CALL AA04($1,[ifelse:($2,0,' ',$2)],$3,$4,$5))#       XMAC 354
#                                                                       XMAC 355
macro:(compchar:,CALLAA09($1,$2,$3,$4,$5,$6,$7,$8))#                    XMAC 356
macro:(compakwd:,$(CALLAA53($1,$3,KZK);IF(KZK.$2.0)$4$))#               XMAC 357
#                                                                       XMAC 358
macro:(getdate:,CALL AA72($1))#                                         XMAC 359
macro:(gettime:,CALL AA71($1))#                                         XMAC 360
macro:(getcpus:,CALL AA70($1))#                                         XMAC 361
macro:(gethkl:,[$(DO KQJ=1,3; $(#                                       XMAC 362
intunpak:(QX($1),JQK,(KQJ-1)*9+3,9)#                                    XMAC 363
intunpak:(QX($1),KZJ,KQJ-1,1)#                                          XMAC 364
IF(KZJ!=0)JQK=-JQK#                                                     XMAC 365
$2(4-KQJ)=FLOAT(JQK)$)$)])#                                             XMAC 366
#                                                                       XMAC 367
macro:(ifeq:,[IF(ABS(($1)-($2))<=ifelse:($3,,small:,$3))])#             XMAC 368
macro:(ifne:,[IF(ABS(($1)-($2))>ifelse:($3,,small:,$3))])#              XMAC 369
macro:(ifvo:,[IF(ABS($1-(voidflg:))<1.E arith:(20,-,mxsgfp:))])#        XMAC 370
macro:(ifnv:,[IF(ABS($1-(voidflg:))>1.E arith:(20,-,mxsgfp:))])#        XMAC 371
macro:(ifch:,[IF((voidflg:)-$1>small:)])#                               XMAC 372
macro:(ifnm:,[IF($1-(voidflg:)>small:)])#                               XMAC 373
#                                                                       XMAC 374
macro:(qxmemory:,[$(IF($1>QXMAX)iquit:(AA0001)#                         XMAC 375
DO IQXZ=QXCUR+1,$1;QX(IQXZ)=0.;QXCUR=$1$)])#                            XMAC 376
macro:(incrqx:,[$(IF($2>QXCUR)$(IQXY=MAX($2,QXCUR)+1000#                XMAC 377
IF(IQXY>QXMAX)iquit:($3);DO IQXZ=QXCUR+1,IQXY;QX(IQXZ)=0.#              XMAC 378
QXCUR=IQXY$)$1=$2$)])#                                                  XMAC 379
#                                                                       XMAC 380
macro:(initcom:, CALL AA07)#                                            XMAC 381
macro:(initprg:, CALL AA08)#                                            XMAC 382
#                                                                       XMAC 383
macro:(intpak:,  CALL AA73($1,$2,$3,$4))#                               XMAC 384
macro:(intunpak:,CALL AA74($1,$2,$3,$4))#                               XMAC 385
macro:(bitlen:,[arith:(mxbtwd:,-,$1)])#                                 XMAC 386
#                                                                       XMAC 387
macro:(ioinp:,IOUNIT(9))#                                               XMAC 388
macro:(ioprt:,IOUNIT(10))#                                              XMAC 389
macro:(iopch:,IOUNIT(11))#                                              XMAC 390
macro:(ioerr:,IOUNIT(12))#                                              XMAC 391
macro:(iofm0:,IOUNIT(13))#                                              XMAC 392
macro:(iofm1:,IOUNIT(14))#                                              XMAC 393
macro:(iofm2:,IOUNIT(15))#                                              XMAC 394
macro:(ioda1:,IOUNIT(16))#                                              XMAC 395
macro:(ioda2:,IOUNIT(17))#                                              XMAC 396
macro:(ioda3:,IOUNIT(18))#                                              XMAC 397
#                                                                       XMAC 398
macro:(iquit:,[CALLAA06("$1",ifelse:($2,,0,$2))])#                      XMAC 399
#                                                                       XMAC 400
macro:(label:,[CALL AA05($1,$2,ifelse:($3,,JWJWJW,$3),#                 XMAC 401
ifelse:($4,,' ',$4), ifelse:($5,,IWIWIW,$5))])#                         XMAC 402
macro:(large:,1.0E+mxsgfp:)#                                            XMAC 403
#                                                                       XMAC 404
macro:(lrhist:,1)#                                                      XMAC 405
macro:(lrlabl:,2)#                                                      XMAC 406
macro:(lrcell:,4)#                                                      XMAC 407
macro:(lrsymm:,5)#                                                      XMAC 408
macro:(lrsgnm:,6)#                                                      XMAC 409
macro:(lrtwin:,7)#                                                      XMAC 410
macro:(lrscat:,8)#                                                      XMAC 411
macro:(lrsequ:,9)#                                                      XMAC 412
macro:(lrddef:,10)#                                                     XMAC 413
macro:(lrexpl:,11)#                                                     XMAC 414
macro:(lrdset:,12)#                                                     XMAC 415
macro:(lrdict:,13)#                                                     XMAC 416
macro:(lrgraf:,14)#                                                     XMAC 417
macro:(lrsite:,15)#                    Special site info                XMAC 418
macro:(lratom:,16)#                                                     XMAC 419
macro:(lrcons:,17)#                                                     XMAC 420
macro:(lrslav:,18)#                                                     XMAC 421
macro:(lrmole:,19)#                                                     XMAC 422
macro:(lrrefl:,20)#                                                     XMAC 423
macro:(lrthet:,21)#                                                     XMAC 424
macro:(lrsfls:,30)#                                                     XMAC 425
macro:(lrrfac:,31)#                                                     XMAC 426
macro:(lrdens:,35)#                                                     XMAC 427
macro:(lrbond:,40)#                                                     XMAC 428
macro:(lrcont:,41)#                                                     XMAC 429
macro:(lrangl:,42)#                                                     XMAC 430
macro:(lrdihe:,43)#                                                     XMAC 431
macro:(lrrigi:,44)#                                                     XMAC 432
#                                                                       XMAC 433
macro:(locase:,CALLAA58($1,$2,$3,1))#                                   XMAC 434
macro:(upcase:,CALLAA58($1,$2,$3,0))#                                   XMAC 435
#                                                                       XMAC 436
macro:(mxchim:,200)#                                                    XMAC 437
macro:(mxcout:,200)#                                                    XMAC 438
macro:(mxfdim:,40)#                                                     XMAC 439
macro:(mxfdln:,50)#                                                     XMAC 440
#                                                                       XMAC 441
macro:(prtstat:,IOSPEC(1))#                                             XMAC 442
macro:(prtcmax:,IOSPEC(2))#                                             XMAC 443
macro:(prtlmax:,IOSPEC(3))#                                             XMAC 444
macro:(prtcpin:,IOSPEC(4))#                                             XMAC 445
macro:(prtlpin:,IOSPEC(5))#                                             XMAC 446
#                                                                       XMAC 447
macro:(small:,5.0E-mxsgfp:)#                                            XMAC 448
macro:(stringlim:,IF($1>0)$($2=(BUFIN($1)*(-1.0E-22)+0.001)#            XMAC 449
$3=NINT(BUFIN($1)*(-1.0E-20))-$2*100$))#                                XMAC 450
macro:(voidflg:,-4.E+20)#                                               XMAC 451
#                                                                       XMAC 452
macro:(oznum:,65)#       ## No. of 'ozy remarks' used on error file     XMAC 453
#                                                                       XMAC 454
macro:(lastnucmac:, )#                                                  XMAC 455
#                                                                       XMAC 456
##******************************************************************    XMAC 457
##                                                                      XMAC 458
##                     XTAL SYSTEM COMMON BLOCK                         XMAC 459
##                     ------------------------                         XMAC 460
##                                                                      XMAC 461
## >>>>>>>>> These definitions CANNOT be changed EVER!  <<<<<<<<<<<<    XMAC 462
#                                                                       XMAC 463
extrude:(AACOMN)#                                                       XMAC 464
INTEGER BUFPNT(mxfdim:),# ## Input buffer field pointers (last cols)    XMAC 465
BUFORD(mxfdim:),#         ## Input buffer field order pointers          XMAC 466
CHRCOL,#                  ## Points to first blank in input image       XMAC 467
CHRMAX,#                  ## Points to last non-blank char +1           XMAC 468
CHREOF,#                  ## End-of-file flag line input device         XMAC 469
FIELDF,#                  ## Signals fixed field input in force         XMAC 470
INPBDF,#                  ## Current input archive bdf device number    XMAC 471
IOLRHD(8),#               ## Pointer to header word of logical record   XMAC 472
IOMARK(8),#               ## Basepoint of input output buffer in qx     XMAC 473
IOPKPT(8),#               ## Pointer to show location of next packet    XMAC 474
IOPRCT(8),#               ## Count of records from start of a file      XMAC 475
IORWFL(8),#               ## Read/write file flag for bdf's             XMAC 476
IOUNIT(20),#              ## Array of device numbers                    XMAC 477
IOSPEC(5),#               ## Array of printer specifications            XMAC 478
IOIN2,#                   ## to store the alternative line ip device    XMAC 479
LABMAX,#                  ## Max length of atom label                   XMAC 480
LABLEN(7),#               ## Length of each label component             XMAC 481
LABPOS(7),#               ## Position of each label component           XMAC 482
LCHROT,#                  ## Last character placed in CHROT buffer      XMAC 483
LINID,#                   ## Calling code sequence number (aa01)        XMAC 484
LINFLG,#                  ## Reread flag in aa01 (default=1)            XMAC 485
LINCT,#                   ## Line count remaining for page              XMAC 486
LINMAS,#                  ## Line count of input ascii master file      XMAC 487
LINRM,#                   ## Request for line 'room' on page            XMAC 488
MASTER,#                  ## Master archive file status yes/no          XMAC 489
NIMAG,#                   ## Count of number of input lines read        XMAC 490
NPAGE,#                   ## Total printer page count                   XMAC 491
PPRIOR,#                  ## Printer priority (default is 3)            XMAC 492
PRVOID,#                  ## Print voidflg: 0=blank/1=@@@@/-1=value     XMAC 493
PRHIST,#                  ## flag to print file a history per run       XMAC 494
PNTPRG,#                  ## Program list character limit               XMAC 495
SETIDF,#                  ## Signals input lines have set ident code    XMAC 496
SYNTXF,#                  ## Syntax checking flag in aao2               XMAC 497
QXCUR,#                   ## Maximum words requested for qx array       XMAC 498
QXMAX,#                   ## Maximum real words in qx array             XMAC 499
QXSTR,#                   ## First word of qx array avail for data      XMAC 500
IQXY,IQXZ,JQJ,JQK,KQJ,KZJ,KZK,IWIWIW,JWJWJW# Macro variables            XMAC 501
#                                                                       XMAC 502
REAL BUFIN(mxfdim:),#     ## Input floating-point field buffer          XMAC 503
BUFOT(mxfdln:),#          ## Output floating-point field buffer         XMAC 504
ELAPST,#                  ## Last value of the cpu clock                XMAC 505
QX(memmax:)#              ## <<<<<<<<<<<<<<<<<<<<<main data storage     XMAC 506
#                                                                       XMAC 507
CHARACTER TITLE*mxcout:,# ## Title character string                     XMAC 508
BLANK*mxchwd:,#           ## Blank characters to fill word              XMAC 509
CHRIP*incr:(mxchim:),#    ## Input character buffer as read             XMAC 510
CHRIN*incr:(mxchim:),#    ## Input character buffer in upper case       XMAC 511
CHROT*mxcout:,#           ## Output character buffer                    XMAC 512
HEADOT*mxcout:,#          ## Output character header buffer             XMAC 513
FILEXT(99)*3,#            ## Filename extension codes                   XMAC 514
FILENM(99)*10,#           ## Filenames applied                          XMAC 515
MASTIN*3,#                ## Input  master bdf extension                XMAC 516
MASTOT*3,#                ## Output master bdf extension                XMAC 517
PROGID*6,#                ## Current program name string                XMAC 518
COMPID*6,#                ## Compound id code string                    XMAC 519
PRGLST*700,#              ## Program names installed                    XMAC 520
XTALHOME*256,#            ## Xtal files Home directory                  XMAC 521
QUITF*6#                  ## Quit code for error message                XMAC 522
#                                                                       XMAC 523
COMMON/SYSF/ BUFIN,BUFOT,ELAPST#                                        XMAC 524
#                                                                       XMAC 525
COMMON/SYSI/ BUFPNT,BUFORD,INPBDF,IOLRHD,IOMARK,IOPKPT,IOPRCT,IORWFL,#  XMAC 526
IOUNIT,IOIN2,CHRMAX,CHRCOL,CHREOF,FIELDF,LINID,LINFLG,LINCT,LINRM,#     XMAC 527
MASTER,PPRIOR,PNTPRG,IOSPEC,NIMAG,NPAGE,SETIDF,SYNTXF,LCHROT,LABMAX,#   XMAC 528
LABPOS,LABLEN,LINMAS,PRVOID,QXMAX,QXCUR,QXSTR,PRHIST,#                  XMAC 529
IQXY,IQXZ,JQJ,JQK,KQJ,KZJ,KZK,IWIWIW,JWJWJW# Macro variables            XMAC 530
#                                                                       XMAC 531
COMMON/SYSC/ BLANK,CHRIP,CHRIN,CHROT,TITLE,PROGID,COMPID,PRGLST,#       XMAC 532
FILEXT,FILENM,MASTIN,MASTOT,QUITF,HEADOT,XTALHOME#                      XMAC 533
#                                                                       XMAC 534
COMMON/QXDATA/ QX#       ## Main data storage array                     XMAC 535
endext:#                                                                XMAC 536
#ENDALL*ENDALL*ENDALL*ENDALL*ENDALL*ENDALL*ENDALL*ENDALL*ENDALL*ENDAL   XMAC 537
